<?php
include_once('../../../php/sessionStart.php');
include_once('../../../php/db/dbExec.php');
include_once('../../../php/functions.php');
include_once('../../../php/timezone.php');
include_once('../../../php/privileges.php');
include_once('../../../php/maxExecTime.php');

$bitForm = "ban1040";
$bitMod = "ban";
$empCod = $_SESSION['empCod'];
$usuCod = utf8_decode($_SESSION['usuCod']);
$usuNom = utf8_decode($_SESSION['usuNom']);

switch ($_POST['action']) {
	case 'consultar':
		echo consultar();
		break;

	case 'consultarCorr':
		echo consultarCorr();
		break;
	case 'consultarCorrPol':
		echo consultarCorrPol();
		break;
	case 'consultarCta':
		echo consultarCta();
		break;
		
	case 'mCerrado':
		echo mCerrado();
		break;

	case 'generarPartida':
		echo generarPartida();
		break;

	case 'guardar':
		echo guardar();
		break;

	case 'anular':
		echo anular();
		break;

	case 'borrar':
		echo borrar();
		break;
}

function consultar() {
	global $empCod, $usuNom;

	$priv = new privileges();
	if (!$priv->consult($_SESSION['usuPriv'])) {
		return json_encode($priv->rErrorConsult());
	}

	$func = new functions();

	$tipoCod=$_POST['selTipoCod'];
	$numNum=$_POST['numNum'];
	$selBanCod=$_POST['selBanCod'];

	# QUERYS
	$sMovi = "SELECT * FROM movi WHERE mov_emp='$empCod' AND mov_ban='$selBanCod' AND mov_tipo='$tipoCod' AND mov_num='$numNum'";
	$sPoli_det = "SELECT *, TRIM(pold_cta) AS pold_cta FROM poli_det WHERE pold_emp='$empCod' AND pold_ban='$selBanCod' AND pold_tipo='$tipoCod' AND pold_num='$numNum'";

	# EJECUCION DE QUERYS
	$db = new dbExec();
	$resp = $db->sEx($sMovi, "movi");
	$resp["poli_det"] = $db->sFetchAll($sPoli_det);
	$db->close();

	$func = new functions();
	$resp["asdf"]=$sPoli_det;
	//return $func->jsonEncodeArrayEach($resp, array('cheques', 'poli_det'));
	return $func->jsonEncodeArray($resp, 'movi');
}

function consultarCorr() {
	global $empCod, $usuNom;

	$func = new functions();
	$selBanCod=$_POST['selBanCod'];
	# QUERYS
	$sBancos = "SELECT ban_mon,ban_corr FROM bancos WHERE ban_emp='$empCod' AND ban_num='$selBanCod'";
	
	# EJECUCION DE QUERYS
	$db = new dbExec();
	$resp["bancos"] = $db->sFetchAssoc($sBancos);
	$db->close();

	$func = new functions();
	return $func->jsonEncodeArray($resp, "bancos");
}

function consultarCorrPol() {
	global $empCod, $usuNom;

	$func = new functions();
	$anuselTipo=$_POST['anuselTipo'];
	# QUERYS
	$sCorrpol = "SELECT cp_num FROM corrpol WHERE cp_emp='$empCod' AND cp_tipo='$anuselTipo'";
	
	# EJECUCION DE QUERYS
	$db = new dbExec();
	$resp["corrpol"] = $db->sFetchAssoc($sCorrpol);
	$db->close();

	$func = new functions();
	return $func->jsonEncodeArray($resp, "corrpol");
}

function mCerrado() {
	global $empCod, $usuNom;

	$func = new functions();
	$dtFec=$_POST['dtFec'];
	$nAnio=date("Y", strtotime($dtFec));
	$nMes=date("n", strtotime($dtFec));

	# QUERYS
	$sCiemes = "SELECT ciem_stat FROM ciemes WHERE ciem_emp='$empCod' AND ciem_ano=$nAnio AND ciem_mes=$nMes";
	# EJECUCION DE QUERYS
	$db = new dbExec();
	$resp["ciemes"] = $db->sfetchAssoc($sCiemes);
	$db->close();
	$func = new functions();
	return $func->jsonEncodeArray($resp, "ciemes");
}

function consultarCta() {
	global $empCod;
	$txtCod=utf8_decode($_POST['txtCod']);

	# QUERYS
	$sCuentas = "SELECT c.*, TRIM(cta) AS cta, TRIM(cta_nom) AS cta_nom
				FROM cuentas c WHERE cta='$txtCod' AND cta_emp='$empCod'";
	
	# EJECUCION DE QUERYS
	$db = new dbExec();
	$resp = $db->sEx($sCuentas, "cuentas");
	$db->close();

	$func = new functions();
	return $func->jsonEncodeArray($resp, "cuentas");
}

function guardar() {
	global $empCod, $usuNom, $bitMod, $bitForm, $selBanCod, $selBanaCod, $banaant, $selTipoCod;

	$priv = new privileges();
	if (!$priv->modify($_SESSION['usuPriv'])) {
		return json_encode($priv->rErrorModify());
	}

	$func = new functions();

	$numNum=$_POST['numNum'];
	$nuevocorr=$numNum+1;
	$selTipoCod=$_POST['selTipoCod'];
	$selBanCod=$_POST['selBanCod'];
	$selBanMon=$_POST['selBanMon'];
	$selBanaCod=$_POST['selBanaCod'];
	$selBanaMon=$_POST['selBanaMon'];
	$dtFec=$_POST['dtFec'];
	$crDH=$_POST['crDH'];
	$numTcam=$_POST['numTcam'];	
	$numTot=$_POST['numTot'];
	$totant=$_POST['totant'];
	$dhant=$_POST['dhant'];
	$banaant=$_POST['banaant'];
	$txtCon=utf8_decode($_POST['txtCon']);
	$jsonPol=json_decode($_POST['tblPol']);
	$jsonPolAnt=json_decode($_POST['tblPolAnt']);
	$numAnio=date("Y", strtotime($dtFec));
	$numMes=date("n", strtotime($dtFec));
	$numAnioAnt=date("Y", strtotime($dtFec));
	$numMesAnt=date("n", strtotime($dtFec));
	$dtGrabado=date("Y-m-d H:i:s", STRTOTIME(date('h:i:sa')));
    $totQ = round($numTot*$numTcam,2);
	$empTasa = utf8_decode($_SESSION["empTasa"]);
	$valTota=0;
    if ($selTipoCod == "003") { 
       if ($selBanMon == $selBanaMon) {
       	 $valTota = $numTot;
       }
       if ($selBanMon == 1 && $selBanaMon == 2) {
       	 $valTota = round($numTot/$empTasa,2);
	   }
       if ($selBanMon == 2 && $selBanaMon == 1) {
       	 $valTota = round($numTot*$numTcam,2);
	   }
    }   	
    if ($selTipoCod != "003") { 
       $selBanaCod = 0;
    }
    if ($crDH == "D") {
       $vDebe = $numTot;
       $vHaber = 0.00;
    } else {
       $vHaber = $numTot;
       $vDebe = 0.00;
    }
	# QUERYS PARA UN REGISTRO
	$sBancos = "SELECT ban_ctac,ban_corr FROM bancos WHERE ban_emp='$empCod' AND ban_num='$selBanCod'";

	$sSaldob = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";

	$sSaldoba = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";

	$sSaldobaant = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$banaant'";

	$iMovi = "INSERT INTO movi(mov_emp, mov_tipo, mov_ban, mov_bana, mov_num, mov_fec, mov_tot, mov_tcam,  mov_con, mov_debacr, mov_ulcam) VALUES ('$empCod','$selTipoCod','$selBanCod','$selBanaCod','$numNum','$dtFec','$numTot','$numTcam','$txtCon','$crDH','$usuNom')";

	$uMovi = "UPDATE movi SET mov_fec='$dtFec', mov_tcam='$numTcam', mov_tot='$numTot', mov_debacr='$crDH', mov_con='$txtCon', mov_ulcam='$usuNom' WHERE mov_emp='$empCod' AND mov_ban='$selBanCod' AND mov_tipo='$selTipoCod' AND mov_num='$numNum'";

	$iMovAcu = "INSERT INTO mov_acu(ma_emp, ma_tipo, ma_ban, ma_num, ma_fec, ma_debe, ma_haber,  ma_con, ma_stat) VALUES ('$empCod','$selTipoCod','$selBanCod','$numNum','$dtFec','$vDebe','$vHaber','$txtCon','P')";

	$uMovAcu = "UPDATE mov_acu SET ma_fec='$dtFec', ma_debe='$vDebe', ma_haber='$vHaber', ma_con='$txtCon'  WHERE ma_emp='$empCod' AND ma_ban='$selBanCod' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$iMovAcua = "INSERT INTO mov_acu(ma_emp, ma_tipo, ma_ban, ma_num, ma_fec, ma_debe, ma_con, ma_stat) VALUES ('$empCod','$selTipoCod','$selBanaCod','$numNum','$dtFec','$valTota','$txtCon','P')";

	$sMovAcua = "SELECT * FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$dMovAcua = "DELETE FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$iPolizas = "INSERT INTO polizas(pol_emp, pol_fec, pol_ban, pol_tipo, pol_num, pol_con, pol_ulcam, pol_grabado, pol_tipoi, pol_nit) VALUES ('$empCod','$dtFec','$selBanCod','$selTipoCod','$numNum','$txtCon','$usuNom','$dtGrabado','','')";

	$uPolizas = "UPDATE polizas SET pol_fec='$dtFec',pol_con='$txtCon', pol_ulcam='$usuNom', pol_grabado='$dtGrabado' WHERE pol_emp='$empCod' AND pol_ban='$selBanCod' AND pol_tipo='$selTipoCod' AND pol_num='$numNum'";

	function sCuentas($cta) { 
		global $empCod;
		return "SELECT * FROM cuentas WHERE cta_emp='$empCod' AND cta='$cta'";
	}

	function sCierres($cta, $numAnio, $numMes) { 
		global $empCod;
		return "SELECT * FROM cierres WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function uCierres($cta, $numAnio, $numMes, $mdebe, $mhaber) { 
		global $empCod, $usuNom;
		return "UPDATE cierres SET cie_mdebe=$mdebe, cie_mhaber=$mhaber, cie_ulcam='$usuNom' WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function iCierres($cta, $numAnio, $numMes, $mdebe, $mhaber) { 
		global $empCod, $usuNom;
		return "INSERT INTO cierres(cie_emp, cie_ano, cie_mes, cie_cta, cie_mdebe, cie_mhaber, cie_ulcam) VALUES('$empCod',$numAnio,$numMes,'$cta',$mdebe,$mhaber,'$usuNom')";	    
	}

	function uSaldob($nvalor) { 
		global $empCod, $usuNom, $selBanCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";
	}

	function iSaldob($nvalor) { 
		global $empCod, $usuNom, $selBanCod;
		return "INSERT INTO saldob(salb_emp, salb_num, salb_saldo) VALUES('$empCod','$selBanCod',$nvalor)";
	}

	function uSaldoba($nvalor) { 
		global $empCod, $usuNom, $selBanaCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";
	}

	function iSaldoba($nvalor) { 
		global $empCod, $usuNom, $selBanaCod;
		return "INSERT INTO saldob(salb_emp, salb_num, salb_saldo) VALUES('$empCod','$selBanaCod',$nvalor)";
	}

	function uSaldobaant($nvalor) { 
		global $empCod, $usuNom, $banaant;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$banaant'";
	}


	# QUERYS PARA VARIOS REGISTROS
	$iPoli_det = "INSERT INTO poli_det (pold_emp, pold_fec, pold_ban, pold_tipo, pold_num, pold_cta, pold_ctan, pold_debe, pold_haber, pold_tipoi, pold_nit) VALUES ";
	foreach ($jsonPol as $obj) {
		$obj->cta = utf8_decode($obj->cta);
		$obj->ctaNom = utf8_decode($obj->ctaNom);
		$iPoli_det = $iPoli_det."('$empCod','$dtFec','$selBanCod','$selTipoCod','$numNum','$obj->cta','$obj->ctaNom','$obj->debe','$obj->haber','','')".$func->addValues($obj, $jsonPol);
	}

	$dPolizas = "DELETE FROM polizas WHERE pol_emp='$empCod' AND pol_ban='$selBanCod' AND pol_tipo='$selTipoCod' AND pol_num='$numNum'";

	$dPoli_det = "DELETE FROM poli_det WHERE pold_emp='$empCod' AND pold_ban='$selBanCod' AND pold_tipo='$selTipoCod' AND pold_num='$numNum'";

	# EJECUCION DE QUERYS 
	$db = new dbExec();

	// Revisa si hay algun problema en la partida, para ver si permite grabar o no
	$probpol1="X";
	$probpol2="A";	
	$probpol3="A";	
	$select["bancos"] = $db->query($sBancos);
	$fetchAssoc["bancos"] = $db->fetchAssoc($select["bancos"]);		
	$ctaBanco = trim($fetchAssoc["bancos"]["ban_ctac"]);
	foreach ($jsonPol as $obj) {
		$ctapol = trim($obj->cta);
		$debe = trim($obj->debe);
		$haber = trim($obj->haber);

		$select["cuentas"] = $db->query(sCuentas($ctapol));
		$fetchAssoc["cuentas"] = $db->fetchAssoc($select["cuentas"]);
		//$ctaC = trim($fetchAssoc["cuentas"]["cta"]);
		if ($db->numRows($select["cuentas"]) == 0) {
			$probpol1 = "A";
		}
		if ($ctapol == $ctaBanco) {
			$probpol2 = "X";
		}
		if ($ctapol == $ctaBanco && $totQ == $haber && $crDH == "A") {
			$probpol3 = "X";
		}
		if ($ctapol == $ctaBanco && $totQ == $debe && $crDH == "D") {
			$probpol3 = "X";
		}
	}
	//
	if ($selTipoCod == '001.01') {
		$probpol1="X";
		$probpol2="X";	
		$probpol3="X";	
	}

	if ($probpol1 == "X" && $probpol2 == "X" && $probpol3 == "X") {
		#Para Actualizar el saldo del banco
		$select["saldob"] = $db->query($sSaldob);
		if ($db->numRows($select["saldob"]) == 0) {
			$vSaldo = 0;
			if ($crDH == "D") {
			   $nvalor = ($vSaldo + $numTot);
			} else {
			   $nvalor = ($vSaldo - $numTot);
			}				   
			$db->query(iSaldob($nvalor));
		} else {
			$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
			$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
			if ($totant>0.00) {
				if ($dhant == "D") {
					$nvalor = ($vSaldo-$totant);
				} else {
					$nvalor = ($vSaldo+$totant);
				}
	 		    $db->query(uSaldob($nvalor));
	 		    $vSaldo=$nvalor;
			}
			if ($crDH == "D") {
				$nvalor = ($vSaldo+$numTot);
			} else {
				$nvalor = ($vSaldo-$numTot);
			}
			$db->query(uSaldob($nvalor));
		}
		# Para el segundo Banco a este banco si D, debe restar y A debe sumar
		if ($selTipoCod == "003" && $banaant > 0) {
			$select["mov_acu"] = $db->query($sMovAcua);
			$fetchAssoc["mov_acu"] = $db->fetchAssoc($select["mov_acu"]);		
			$totanta = $fetchAssoc["mov_acu"]["ma_debe"];

			$select["saldob"] = $db->query($sSaldobaant);
			$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
			$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
			if ($totanta>0.00) {
				if ($dhant == "D") {
					$nvalor = ($vSaldo+$totanta);
				} else {
					$nvalor = ($vSaldo-$totanta);
				}
	 		    $db->query(uSaldobaant($nvalor));
			}
		}
		if ($selTipoCod == "003" && $selBanaCod > 0) {
			$select["saldob"] = $db->query($sSaldoba);
			if ($db->numRows($select["saldob"]) == 0) {
				$vSaldo = 0;
				if ($crDH == "D") {
				   $nvalor = ($vSaldo - $valTota);
				} else {
				   $nvalor = ($vSaldo + $valTota);
				}				   
				$db->query(iSaldoba($nvalor));
			} else {
				$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
				$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
				if ($crDH == "D") {
					$nvalor = ($vSaldo-$valTota);
				} else {
					$nvalor = ($vSaldo+$valTota);
				}
				$db->query(uSaldoba($nvalor));
			}
		}
		//

		if ($func->stringToBool($_POST['nuevo'])) {
			$resp = $db->iEx($iMovi);
			$resp = $db->iEx($iMovAcu);
			if ($selTipoCod == "003") {
			   $resp = $db->iEx($iMovAcua);
			}
			$db->iEx($func->iBitacora(utf8_decode("Se creó Documento Tipo: $selTipoCod No.: $numNum  Banco: $selBanCod Fecha: $dtFec Usuario: ").$usuNom, $bitMod, $bitForm));
		} else {
			$resp = $db->uEx($uMovi);
			$resp = $db->iEx($uMovAcu);
			if ($selTipoCod == "003") {
			   $resp = $db->dEx($dMovAcua);
			   $resp = $db->iEx($iMovAcua);
			}
			$db->iEx($func->iBitacora(utf8_decode("Se modificó Documento Tipo: $selTipoCod No.: $numNum  Banco: $selBanCod Fecha: $dtFec Usuario: ").$usuNom, $bitMod, $bitForm));
		}

	    if ($selTipoCod != '001.01') {
			$db->dEx($dPolizas);
			$db->dEx($iPolizas);

			$db->dEx($dPoli_det);
			if (!$func->jsonEmpty($jsonPol)) {
				$db->iEx($iPoli_det);
			}

			// PARA REVERTIR LOS CIERRES
			foreach ($jsonPolAnt as $obj) {
				$cta = $obj->pold_cta;
				$numAnioAnt=date("Y", strtotime($obj->pold_fec));
				$numMesAnt=date("n", strtotime($obj->pold_fec));

				while (!empty($cta)) {
					$select["cuentas"] = $db->query(sCuentas($cta));
					$select["cierres"] = $db->query(sCierres($cta, $numAnioAnt, $numMesAnt));

					$fetchAssoc["cuentas"] = $db->fetchAssoc($select["cuentas"]);
					$ctaActa = trim($fetchAssoc["cuentas"]["cta_acta"]);

					$fetchAssoc["cierres"] = $db->fetchAssoc($select["cierres"]);
					$mdebe=$fetchAssoc["cierres"]["cie_mdebe"]-$obj->pold_debe;
					$mhaber=$fetchAssoc["cierres"]["cie_mhaber"]-$obj->pold_haber;

					$db->query(uCierres($cta, $numAnioAnt, $numMesAnt, $mdebe, $mhaber));

					$cta = $ctaActa;
				}
			}

			// PARA APLICAR LOS CIERRES
			foreach ($jsonPol as $obj) {
				$cta = $obj->cta;
				while (!empty($cta)) {
					$select["cuentas"] = $db->query(sCuentas($cta));
					$select["cierres"] = $db->query(sCierres($cta, $numAnio, $numMes));

					$fetchAssoc["cuentas"] = $db->fetchAssoc($select["cuentas"]);
					$ctaActa = trim($fetchAssoc["cuentas"]["cta_acta"]);

					if ($db->numRows($select["cierres"]) > 0) {
						$fetchAssoc["cierres"] = $db->fetchAssoc($select["cierres"]);
						$mdebe=$fetchAssoc["cierres"]["cie_mdebe"]+$obj->debe;
						$mhaber=$fetchAssoc["cierres"]["cie_mhaber"]+$obj->haber;

						$db->query(uCierres($cta, $numAnio, $numMes, $mdebe, $mhaber));
					} else {
						$mdebe=$obj->debe;
						$mhaber=$obj->haber;
						$db->query(iCierres($cta, $numAnio, $numMes, $mdebe, $mhaber));
					}
					$cta = $ctaActa;
				}

			}
		}
	}

	$db->close();
	
	$resp["dtGrabado"]=$dtGrabado;
	$resp["probpol1"]=$probpol1;
	$resp["probpol2"]=$probpol2;
	$resp["probpol3"]=$probpol3;

	return json_encode($resp);
}

function borrar() {
	global $empCod, $usuNom, $bitMod, $bitForm, $selTipoCod, $selBanCod, $selBanaCod, $banaant;

	$func = new functions();

	$numNum=$_POST['numNum'];
	$selTipoCod=$_POST['selTipoCod'];
	$selBanCod=$_POST['selBanCod'];
	$selBanaCod=$_POST['selBanaCod'];
	$dtFec=$_POST['dtFec'];
	$jsonPolAnt=json_decode($_POST['tblPolAnt']);
	$numAnio=date("Y", strtotime($dtFec));
	$numMes=date("n", strtotime($dtFec));
	$numAnioAnt=date("Y", strtotime($dtFec));
	$numMesAnt=date("n", strtotime($dtFec));
	$totant=$_POST['totant'];
	$dhant=$_POST['dhant'];
	$banaant=$_POST['banaant'];

	# QUERYS
	$sSaldob = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";

	$sSaldoba = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";

	$sSaldobaant = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$banaant'";

	$dMovi = "DELETE FROM movi WHERE mov_emp='$empCod' AND mov_ban='$selBanCod' AND mov_tipo='$selTipoCod' AND mov_num='$numNum'";

	$dMovAcu = "DELETE FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$selBanCod' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$sMovAcua = "SELECT * FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$dMovAcua = "DELETE FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$dPolizas = "DELETE FROM polizas WHERE pol_emp='$empCod' AND  pol_ban='$selBanCod' AND pol_tipo='$selTipoCod' AND pol_num='$numNum'";

	$dPoli_det = "DELETE FROM poli_det WHERE pold_emp='$empCod' AND pold_ban='$selBanCod' AND pold_tipo='$selTipoCod' AND pold_num='$numNum'";

	function sCuentas($cta) { 
		global $empCod;
		return "SELECT * FROM cuentas WHERE cta_emp='$empCod' AND cta='$cta'";
	}

	function sCierres($cta, $numAnio, $numMes) { 
		global $empCod;
		return "SELECT * FROM cierres WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function uCierres($cta, $numAnio, $numMes, $mdebe, $mhaber) { 
		global $empCod, $usuNom;
		return "UPDATE cierres SET cie_mdebe=$mdebe, cie_mhaber=$mhaber, cie_ulcam='$usuNom' WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function uSaldob($nvalor) { 
		global $empCod, $usuNom, $selBanCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";
	}

	function uSaldoba($nvalor) { 
		global $empCod, $usuNom, $selBanaCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";
	}


	function uSaldobaant($nvalor) { 
		global $empCod, $usuNom, $banaant;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$banaant'";
	}

	# EJECUCION DE QUERYS 
	$db = new dbExec();
	$resp = $db->dEx($dPolizas);
	$db->dEx($dMovi);
	$db->dEx($dMovAcu);
	$db->dEx($dPoli_det);

	// PARA REVERTIR LOS CIERRES
	foreach ($jsonPolAnt as $obj) {
		$cta = $obj->pold_cta;
		$numAnioAnt=date("Y", strtotime($obj->pold_fec));
		$numMesAnt=date("n", strtotime($obj->pold_fec));
		while (!empty($cta)) {
			$select["cuentas"] = $db->query(sCuentas($cta));
			$select["cierres"] = $db->query(sCierres($cta, $numAnioAnt, $numMesAnt));

			$fetchAssoc["cuentas"] = $db->fetchAssoc($select["cuentas"]);
			$ctaActa = trim($fetchAssoc["cuentas"]["cta_acta"]);

			$fetchAssoc["cierres"] = $db->fetchAssoc($select["cierres"]);
			$mdebe=$fetchAssoc["cierres"]["cie_mdebe"]-$obj->pold_debe;
			$mhaber=$fetchAssoc["cierres"]["cie_mhaber"]-$obj->pold_haber;

			$db->query(uCierres($cta, $numAnioAnt, $numMesAnt, $mdebe, $mhaber));

			$cta = $ctaActa;
		}
	}

	#Para Actualizar el saldo del banco
	$select["saldob"] = $db->query($sSaldob);
	if ($db->numRows($select["saldob"]) == 0) {
	} else {
		$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
		$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
		if ($totant>0.00) {
			if ($dhant == "D") {
				$nvalor = ($vSaldo-$totant);
			} else {
				$nvalor = ($vSaldo+$totant);
			}
 		    $db->query(uSaldob($nvalor));
 		    $vSaldo=$nvalor;
		}
	}
	#Para el segundo Banco cuando son transferencias
	if ($selTipoCod == "003" && $banaant > 0) {
		$select["mov_acu"] = $db->query($sMovAcua);
		$fetchAssoc["mov_acu"] = $db->fetchAssoc($select["mov_acu"]);		
		$totanta = $fetchAssoc["mov_acu"]["ma_debe"];

		$select["saldob"] = $db->query($sSaldobaant);
		$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
		$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
		if ($totanta>0.00) {
			if ($dhant == "D") {
				$nvalor = ($vSaldo+$totanta);
			} else {
				$nvalor = ($vSaldo-$totanta);
			}
 		    $db->query(uSaldobaant($nvalor));
		}
	}
	//
    if ($selTipoCod == "003") { 
	   $db->uEx($dMovAcua);
	}

	$db->iEx($func->iBitacora(utf8_decode("Se borró Documento Tipo: $selTipoCod  No.: $numNum Banco: $selBanCod Fecha: $dtFec Usuario: ").$usuNom, $bitMod, $bitForm));

	$db->close();

	return json_encode($resp);
}
function anular() {
	global $empCod, $usuNom, $bitMod, $bitForm, $selTipoCod, $selBanCod, $selBanaCod, $banaant;

	$func = new functions();

	$numNum=$_POST['numNum'];
	$selTipoCod=$_POST['selTipoCod'];
	$selBanCod=$_POST['selBanCod'];
	$selBanaCod=$_POST['selBanaCod'];
	$dtFec=$_POST['dtFec'];
	$jsonPolAnt=json_decode($_POST['tblPolAnt']);
	$numAnio=date("Y", strtotime($dtFec));
	$numMes=date("n", strtotime($dtFec));
	$numAnioAnt=date("Y", strtotime($dtFec));
	$numMesAnt=date("n", strtotime($dtFec));
	$totant=$_POST['totant'];
	$dhant=$_POST['dhant'];
	$banaant=$_POST['banaant'];
	$Anulado="**** ANULADO ****";
	$txtConAnu="**** ANULADO ****";
	$valAnu=0.00;
	# QUERYS
	$sSaldob = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";

	$sSaldoba = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";

	$sSaldobaant = "SELECT * FROM saldob WHERE salb_emp='$empCod' AND salb_num='$banaant'";

	$uMovi = "UPDATE movi SET mov_tot=$valAnu, mov_con='$txtConAnu' WHERE mov_emp='$empCod' AND mov_ban='$selBanCod' AND mov_tipo='$selTipoCod' AND mov_num='$numNum'";

	$uMovAcu = "UPDATE mov_acu SET ma_debe=$valAnu, ma_haber=$valAnu, ma_bene='$Anulado', ma_con='$txtConAnu', ma_stat='A' WHERE ma_emp='$empCod' AND ma_ban='$selBanCod' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$sMovAcua = "SELECT * FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$dMovAcua = "DELETE FROM mov_acu WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$uMovAcua = "UPDATE mov_acu SET ma_debe=$valAnu, ma_haber=$valAnu, ma_bene='$Anulado', ma_con='$txtConAnu', ma_stat='A' WHERE ma_emp='$empCod' AND ma_ban='$banaant' AND ma_tipo='$selTipoCod' AND ma_num='$numNum'";

	$uPolizas = "UPDATE polizas SET pol_con='$txtConAnu' WHERE pol_emp='$empCod' AND pol_ban='$selBanCod' AND pol_tipo='$selTipoCod' AND pol_num='$numNum'";

	$uPoli_det = "UPDATE poli_det SET pold_debe=$valAnu, pold_haber=$valAnu WHERE pold_emp='$empCod' AND pold_ban='$selBanCod' AND pold_tipo='$selTipoCod' AND pold_num='$numNum'";

	function sCuentas($cta) { 
		global $empCod;
		return "SELECT * FROM cuentas WHERE cta_emp='$empCod' AND cta='$cta'";
	}

	function sCierres($cta, $numAnio, $numMes) { 
		global $empCod;
		return "SELECT * FROM cierres WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function uCierres($cta, $numAnio, $numMes, $mdebe, $mhaber) { 
		global $empCod, $usuNom;
		return "UPDATE cierres SET cie_mdebe=$mdebe, cie_mhaber=$mhaber, cie_ulcam='$usuNom' WHERE cie_emp='$empCod' AND cie_ano=$numAnio AND cie_mes=$numMes AND cie_cta='$cta'";
	}

	function uSaldob($nvalor) { 
		global $empCod, $usuNom, $selBanCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanCod'";
	}

	function uSaldoba($nvalor) { 
		global $empCod, $usuNom, $selBanaCod;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$selBanaCod'";
	}


	function uSaldobaant($nvalor) { 
		global $empCod, $usuNom, $banaant;
		return "UPDATE saldob SET salb_saldo=$nvalor WHERE salb_emp='$empCod' AND salb_num='$banaant'";
	}

	# EJECUCION DE QUERYS 
	$db = new dbExec();
	$resp = $db->uEx($uMovi);
	$db->uEx($uMovAcu);
	// PARA ANULAR PARTIDA Y REVERTIR CIERRES 
	$resp = $db->anEx($uPolizas);
	$db->uEx($uPoli_det);
	// PARA REVERTIR LOS CIERRES
	foreach ($jsonPolAnt as $obj) {
		$cta = $obj->pold_cta;
		$numAnioAnt=date("Y", strtotime($obj->pold_fec));
		$numMesAnt=date("n", strtotime($obj->pold_fec));
		while (!empty($cta)) {
			$select["cuentas"] = $db->query(sCuentas($cta));
			$select["cierres"] = $db->query(sCierres($cta, $numAnioAnt, $numMesAnt));

			$fetchAssoc["cuentas"] = $db->fetchAssoc($select["cuentas"]);
			$ctaActa = trim($fetchAssoc["cuentas"]["cta_acta"]);

			$fetchAssoc["cierres"] = $db->fetchAssoc($select["cierres"]);
			$mdebe=$fetchAssoc["cierres"]["cie_mdebe"]-$obj->pold_debe;
			$mhaber=$fetchAssoc["cierres"]["cie_mhaber"]-$obj->pold_haber;

			$db->query(uCierres($cta, $numAnioAnt, $numMesAnt, $mdebe, $mhaber));

			$cta = $ctaActa;
		}
	}

	#Para Actualizar el saldo del banco
	$select["saldob"] = $db->query($sSaldob);
	if ($db->numRows($select["saldob"]) == 0) {
	} else {
		$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
		$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
		if ($totant>0.00) {
			if ($dhant == "D") {
				$nvalor = ($vSaldo-$totant);
			} else {
				$nvalor = ($vSaldo+$totant);
			}
 		    $db->query(uSaldob($nvalor));
 		    $vSaldo=$nvalor;
		}
	}
	#Para el segundo Banco cuando son transferencias
	if ($selTipoCod == "003" && $banaant > 0) {
		$select["mov_acu"] = $db->query($sMovAcua);
		$fetchAssoc["mov_acu"] = $db->fetchAssoc($select["mov_acu"]);		
		$totanta = $fetchAssoc["mov_acu"]["ma_debe"];

		$select["saldob"] = $db->query($sSaldobaant);
		$fetchAssoc["saldob"] = $db->fetchAssoc($select["saldob"]);		
		$vSaldo = $fetchAssoc["saldob"]["salb_saldo"];
		if ($totanta>0.00) {
			if ($dhant == "D") {
				$nvalor = ($vSaldo+$totanta);
			} else {
				$nvalor = ($vSaldo-$totanta);
			}
 		    $db->query(uSaldobaant($nvalor));
		}
	}
	//
    if ($selTipoCod == "003") { 
	   $db->uEx($uMovAcua);
	}

	$db->iEx($func->iBitacora(utf8_decode("Se Anulo Documento Tipo: $selTipoCod  No.: $numNum Banco: $selBanCod  Usuario: ").$usuNom, $bitMod, $bitForm));

	$db->close();

	return json_encode($resp);
}


function generarPartida() {
	global $empCod;
	$numNum=$_POST['numNum'];
	$selTipoCod=$_POST['selTipoCod'];
	$selBanCod=$_POST['selBanCod'];
	$dtFec=$_POST['dtFec'];
	$numTot=$_POST['numTot'];
	$numTcam=$_POST['numTcam'];
	$selBanaCod=$_POST['selBanaCod'];
	$jsonPol=json_decode($_POST['tblPol']);
	$ctaClien="112011";
	# QUERYS
	$sBancos = "SELECT ban_ctac FROM bancos WHERE ban_emp='$empCod' AND ban_num='$selBanCod'";
	$sBancosa = "SELECT ban_ctac FROM bancos WHERE ban_emp='$empCod' AND ban_num='$selBanaCod'";

	function sCuentas($cta) {
		global $empCod;
		return "SELECT TRIM(cta) AS cta, TRIM(cta_nom) AS cta_nom
				FROM cuentas c WHERE cta='$cta' AND cta_emp='$empCod'";
	}
	
	# EJECUCION DE QUERYS
	$func = new functions();
	if (!$func->jsonEmpty($jsonPol)) {
		$resp['partidaYa']=true;		
		return json_encode($resp);
	} else { 
		$db = new dbExec();
		$select["bancos"] = $db->query($sBancos);
		$fetchAssoc["bancos"] = $db->fetchAssoc($select["bancos"]);		
		$ctaBanco = trim($fetchAssoc["bancos"]["ban_ctac"]);
		$resp["ctaBanc"] = ($ctaBanco=="") ? "" : $db->sFetchAssoc(sCuentas((string)$ctaBanco));
		$select["bancosa"] = $db->query($sBancosa);
		$fetchAssoc["bancosa"] = $db->fetchAssoc($select["bancosa"]);		
		$ctaBancoa = trim($fetchAssoc["bancosa"]["ban_ctac"]);
		$resp["ctaBanac"] = ($ctaBancoa=="") ? "" : $db->sFetchAssoc(sCuentas((string)$ctaBancoa));
		$resp["ctaClien"] = ($ctaClien=="") ? "" : $db->sFetchAssoc(sCuentas((string)$ctaClien));
		$db->close();
		$func = new functions();
		$resp['partidaYa']=false;		
		return $func->jsonEncodeArrayEach($resp, array('ctaBanc','ctaBanac','ctaClien'));
	}		
}

?>